-- Mario : Operation espace by Bibi595
-- Based on SpaceRocks by Xigency
------------------------------------------------------------
-- INITIALIZATION

math.randomseed(os.time())
maxStars = 150
maxAliens = 1
maxAlins = 1
maxRocks =3
maxLasers=40
maxExplosions = 10
laserCharge=10
shootWait=0
exframes=9
rocksLeft=5
score=0
level=0
health=10
lbActive=0
sccnt=0


width = 480
height = 272
gosound = Sound.load("home/game/son/mario.wav", false)
expsnd = Sound.load("home/game/son/1.wav")
lasersnd = Sound.load("home/game/son/2.wav")
elasersnd = Sound.load("home/game/son/3.wav")
startscreenimagg = Image.load("home/game/images1/g.png")
startscreenimagh = Image.load("home/game/images1/game over.PNG")
startscreenimagnivo = Image.load("home/game/images1/nivo.png")
shipimg = Image.load("home/game/images1/mario.png")
alienimg = Image.load("home/game/images1/wario.png")
alinimg = Image.load("home/game/images1/bowser.png")
rockimg = Image.load("home/game/images1/boule.png")
expimg = Image.load("home/game/images1/explosion1.png")
exprockimg = Image.load("home/game/images1/explosion2.png")
laserimg = Image.load("home/game/images1/balle.png")
elaserimg = Image.load("home/game/images1/eballe.png")
shipX=width/2
shipY=height-40

lasers = {}
explosions = {}
stars = {}
aliens = {}
alins = {}
rocks = {}
starc = {}
fadegreen = {}
fadered = {}
fadeblue = {}
fadewhite = {}
fadewhitered = {}

for i=1, 5 do
	starc[i] = {}
	starc[i].clr= Color.new(295-(i*40),295-(i*40),295-(i*40))
end


white = Color.new(255,255,255)
black = Color.new(0,0,0)
blue = Color.new(0,0,255)
green = Color.new(0,255,0)
red = Color.new(255,0,0)

for i=1, 255 do
	fadegreen[i] = {}
	fadegreen[i].clr= Color.new(0,i,0)
end

for i=1, 255 do
	fadeblue[i] = {}
	fadeblue[i].clr= Color.new(0,0,i)
end


for i=1, 255 do
	fadered[i] = {}
	fadered[i].clr= Color.new(i,0,0)
end

for i=1, 255 do
	fadewhitered[i] = {}
	fadewhitered[i].clr= Color.new(255,i,i)
end

for i=1, 255 do
	fadewhite[i] = {}
	fadewhite[i].clr= Color.new(i,i,i)
end

---------------------------------------------
-- FUNCTIONS

function delay(seconds)
	time=seconds*60
	for i=1, time do
		screen.waitVblankStart()
	end
end 

function createStar(i)
	stars[i] = {}
	stars[i].xp=math.random(width)
	stars[i].yp=math.random(height)-height
	z = math.random(4)
	stars[i].ysp = (5-z)
	stars[i].b = z
end

function createAlien(i)
	aliens[i] = {}
	aliens[i].xp=math.random(width-alienimg:width())
	aliens[i].yp=math.random(height)-height-alienimg:height()
	aliens[i].xsp=math.random(5)-5.5
	aliens[i].ysp=math.random(3)+3
	aliens[i].swait=0
end

function createAlin(i)
	alins[i] = {}
	alins[i].xp=math.random(width-alinimg:width())
	alins[i].yp=math.random(height)-height-alinimg:height()
	alins[i].xsp=math.random(3)-5.5
	alins[i].ysp=math.random(3)+3
	alins[i].swait=0
end

function createRock(i)
	rocks[i] = {}
	rocks[i].xp=math.random(width-rockimg:width())
	rocks[i].yp=math.random(height)-height-rockimg:height()
	rocks[i].xsp=math.random(5)-2.5
	rocks[i].ysp=math.random(5)+2
end


function createExplosion(x,y,type)
	v=expsnd:play()
	ex=0
	for i=1, maxExplosions do
		if ex==1 then break end
		if explosions[i].active==0 then
			explosions[i] = {}
			explosions[i].xp=x
			explosions[i].yp=y
			explosions[i].type=type
			explosions[i].active=1
			explosions[i].frame=0
			ex=1
		end
	end
end

function createLaser(x,y,type)
	if type==1 then v=lasersnd:play() end
	if type==2 then v=elasersnd:play() end
	ex=0
	for i=1,maxLasers do
		if ex==1 then break end
		if lasers[i].active==0 then
			lasers[i] = {}
			lasers[i].xp=x
			lasers[i].yp=y
			lasers[i].type=type
			lasers[i].active=1
			ex=1
		end
	end
end



for i=1, maxStars do
	createStar(i)
	stars[i].yp = stars[i].yp + height
end



function updateStars()
	for i=1, maxStars do
		speed = stars[i].ysp
		stars[i].yp = stars[i].yp + speed
		sx = stars[i].xp
		sy = stars[i].yp
		b = stars[i].b
		clr = starc[b].clr

		if sy<height and sy>0 and sx<width and sx>0 then 
			screen:pixel(sx, sy, clr)
		else
			createStar(i) 
		end

	end
end

function updateAliens()
	for i=1, maxAliens do
		aliens[i].xp=aliens[i].xp+aliens[i].xsp
		aliens[i].yp=aliens[i].yp+aliens[i].ysp
		x=aliens[i].xp
		y=aliens[i].yp
		if aliens[i].swait>0 then aliens[i].swait=aliens[i].swait-1 end
		if x<0 or x>width-alienimg:width() then aliens[i].xsp=-aliens[i].xsp end

		if y<height then 
			if math.random(30)==3 and aliens[i].swait==0 and y>0-alienimg:width() then 
				createLaser(x+(alienimg:width()/2),y+alienimg:height(),2) 
				aliens[i].swait=8
			end
			
			if y>0-alienimg:height() then screen:blit(x,y,alienimg) end
		else
			createAlien(i) 
		end


		if lbActive==1 then
			if lbX>x and lbX<x+alienimg:width() then
				createExplosion(x,y,1)
				createAlien(i)
				score=score+1000
			end
		end

	end
end 

function updateAlins()
	for i=1, maxAlins do
		alins[i].xp=alins[i].xp+alins[i].xsp
		alins[i].yp=alins[i].yp+alins[i].ysp
		x=alins[i].xp
		y=alins[i].yp
		if alins[i].swait>0 then alins[i].swait=alins[i].swait-1 end
		if x<0 or x>width-alinimg:width() then alins[i].xsp=-alins[i].xsp end

		if y<height then 
			if math.random(30)==3 and alins[i].swait==0 and y>0-alinimg:width() then 
				createLaser(x+(alinimg:width()/2),y+alinimg:height(),2) 
				alins[i].swait=8
			end
			
			if y>0-alinimg:height() then screen:blit(x,y,alinimg) end
		else
			createAlin(i) 
		end


		if lbActive==1 then
			if lbX>x and lbX<x+alinimg:width() then
				createExplosion(x,y,1)
				createAlin(i)
				score=score+1000
			end
		end

	end
end 

function updateRocks()
	for i=1, maxRocks do
		rocks[i].xp=rocks[i].xp+rocks[i].xsp
		rocks[i].yp=rocks[i].yp+rocks[i].ysp
		x=rocks[i].xp
		y=rocks[i].yp

		if y<height then 
			if y>0-rockimg:height() then screen:blit(x,y,rockimg) end
		else
			createRock(i) 
		end

		if shipX+shipimg:width()>rocks[i].xp and shipY+shipimg:height()>rocks[i].yp and shipX<rocks[i].xp+rockimg:width() and shipY<rocks[i].yp+rockimg:width() then
			createExplosion(rocks[i].xp,rocks[i].yp,2)
			createRock(i)
			health=health-1
			rocksLeft=rocksLeft-1
		end

		if lbActive==1 then
			if lbX>rocks[i].xp and lbX<rocks[i].xp+rockimg:width() then
				createExplosion(rocks[i].xp,rocks[i].yp,2)
				createRock(i)
				score=score+1000
				rocksLeft=rocksLeft-1
			end
		end

	end
end 


function drawHud()
	z=laserCharge*20
	w=health*20
	screen:fillRect(10,10,200,10, green)
	screen:fillRect(10,10,w,10, red)
	screen:print(104,11,"Life", white)
	screen:fillRect(10,30,200,10, green)
	screen:fillRect(10,30,z,10, red)
	screen:print(96,31,"Laser", white)
	screen:print(10,230,"Score :", white)
	screen:print(290,11,"Remaining mushrooms :", white)
	screen:print(70,230,score, green)
	screen:print(460,11,rocksLeft, green)
	screen:print(10,250,"Level :", white)
	screen:print(70,250,level, green)

end


function updateExplosions()
	for i=1, maxExplosions do
		if explosions[i].active==1 then
			x=explosions[i].xp
			y=explosions[i].yp
			wid=(expimg:width()/exframes)
			heig=expimg:height()
			xs=wid*explosions[i].frame
			ys=0

			if explosions[i].type==1 then screen:blit(x,y,expimg,xs,ys,wid,heig) end
			if explosions[i].type==2 then screen:blit(x,y,exprockimg,xs,ys,wid,heig) end
			explosions[i].frame=explosions[i].frame+1
			if explosions[i].frame >= (exframes-1) then explosions[i].active=0 end
		end
	end
end

function updateLasers()
	for i=1, maxLasers do
		ex=0
		if lasers[i].active == 1 then
			x=lasers[i].xp
			y=lasers[i].yp

			if lasers[i].type==1 then
				lasers[i].yp=lasers[i].yp-8
				screen:blit(x,y,laserimg)


				for q=1, maxRocks do
					if x>rocks[q].xp and y>rocks[q].yp and x<rocks[q].xp+rockimg:width() and y<rocks[q].yp+rockimg:width() then
						createExplosion(rocks[q].xp,rocks[q].yp,2)
						createRock(q)
						score=score+300
						lasers[i].active=0
						rocksLeft=rocksLeft-1
					end
				end

				for q=1, maxAliens do
					if x>aliens[q].xp and y>aliens[q].yp and x<aliens[q].xp+alienimg:width() and y<aliens[q].yp+alienimg:width() then
						createExplosion(aliens[q].xp,aliens[q].yp,1)
						createAlien(q)
						score=score+800
						lasers[i].active=0
					end
				end

				for q=1, maxAlins do
					if x>alins[q].xp and y>alins[q].yp and x<alins[q].xp+alinimg:width() and y<alins[q].yp+alinimg:width() then
						createExplosion(alins[q].xp,alins[q].yp,1)
						createAlin(q)
						score=score+1300
						lasers[i].active=0
					end
				end

			else
				lasers[i].yp=lasers[i].yp+8
				screen:blit(x,y,elaserimg)

				if x>shipX and y>shipY and x<shipX+shipimg:width() and y<shipY+shipimg:height() then
					createExplosion(shipX,shipY,1)
					health=health-1
					lasers[i].active=0
				end
			end	

			if lasers[i].yp<0 or lasers[i].yp>height then lasers[i].active=0 end
		end
	end
end

function initLevel()

	level=level+1
	maxRocks=level
	maxAliens=level-1
	maxAlins=level-2
	rocksLeft=level*3+2

	for i=1, maxAlins do
		createAlin(i)
	end

	for i=1, maxAliens do
		createAlien(i)
	end

	for i=1, maxRocks do
		createRock(i)
	end

	for i=1, maxExplosions do
		explosions[i] = {}
		explosions[i].active=0
	end

	for i=1, maxLasers do
		lasers[i] = {}
		lasers[i].active=0
	end

	screen:clear(black)
	screen:blit(0,0,startscreenimagnivo)
	screen:print(400,250,"Level: ",black)
	screen:print(450,250,level,red)
	screen.flip()
	delay(3)
end

function pause()
	delay(0.5)
	while true do
		screen:clear(black)
		screen:print(220,110,"Pause",fadered[254].clr)
		screen:print(195,130,"Press Start",fadered[254].clr)
			 screen:print(180,150,"To resume play",fadered[254].clr)
		updateStars()
		drawHud()
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart()
		if Controls.read():start() then break end
	end
	delay(0.5)
end


---------------------------------------
-- cool INTRO

gosound:play()

khit=0

----------------------------------------
-- MENU
delay(0.25)


flash=1
d=1
backc=2

while true do
	screen:clear(fadered[backc].clr)
	screen.waitVblankStart()
	updateStars()
	screen:blit(0,0,startscreenimagg)
	flash=flash+3
	if flash>60 then flash=3 end
	if Controls.read():start() then break end
	backc=backc+d
	if backc>80 or backc<2 then d=-d end
	screen.waitVblankStart()
	screen.flip()
end


initLevel()

-----------------------------------------------------------
-- MAIN LOOP

while true do

	pad = Controls.read()
	ax=0
	ay=0
	ax = pad:analogX()
	ay = pad:analogY()
	if pad:up() then ay=-150 end
	if pad:down() then ay=150 end
	if pad:left() then ax=-150 end
	if pad:right() then ax=150 end
	if pad:select() then
		screen:save("home/game/screenshot/screenshot"..sccnt..".png")
		sccnt=sccnt+1
	end

	if shootWait > 0 then shootWait=shootWait-1 end



	if  (pad:r() or pad:circle()) and shootWait==0 and laserCharge>=1 then 
		createLaser(shipX,shipY+10,1) 
		createLaser(shipX+40,shipY+10,1)
		shootWait=7
		laserCharge=laserCharge-1
	end

	if (pad:l() or pad:cross() or pad:square()) and lbActive==0 and laserCharge>=7 then
		laserCharge=laserCharge-3
		lbActive=1
		lbX=shipX+shipimg:width()/2
		lbY=shipY
		lbL=30
		lbC=254
	end

	if laserCharge<10 then laserCharge=laserCharge+0.05 end


	if ax>32 or ax<-32 then shipX = shipX + ax/20 end
	if ay>32 or ay<-32 then shipY = shipY + ay/20 end


	if shipX>width-shipimg:width() then shipX=width-shipimg:width() end
	if shipX<0 then shipX=0 end
	if shipY>height-shipimg:height() then shipY=height-shipimg:height() end
	if shipY<0 then shipY=0 end


	screen:clear(black)

	updateLasers()
	updateStars()
	updateRocks()

	screen:blit(shipX, shipY, shipimg)


	updateAliens()
	updateAlins()
	updateExplosions()


	if lbActive==1 then
		if lbC>60 then screen:drawLine(lbX-2,height-lbL,lbX-2,height,fadewhite[lbC-60].clr) end
		if lbC>30 then screen:drawLine(lbX-1,height-lbL,lbX-1,height,fadewhite[lbC-30].clr) end
		screen:drawLine(lbX-2,height-lbL,lbX,height,fadewhite[lbC].clr)
		if lbC>30 then screen:drawLine(lbX+1,height-lbL,lbX+1,height,fadewhite[lbC-30].clr) end
		if lbC>60 then screen:drawLine(lbX+2,height-lbL,lbX+2,height,fadewhite[lbC-60].clr) end

		if (height-lbL)>0 then lbL=lbL+30 end
		lbC=lbC-4
		if lbC<5 then lbActive=0 end
	end


	drawHud()

	if pad:triangle() or health<1 then break end

	if pad:start() then pause() end


	screen.waitVblankStart()
	screen.flip()

	if rocksLeft<1 then initLevel() end

end

-------------------------------------
-- GAME OVER

delay(0.25)


flash=1
d=1
backc=2

while true do
	screen:clear(fadered[backc].clr)
	screen.waitVblankStart()
	updateStars()
	screen:blit(0,0,startscreenimagh)
	screen:print(350,180,"Score:", black)
	screen:print(400,180,score, red)
	screen:print(350,200,"Niveau:", black)
	screen:print(409,200,level, red)
	screen:print(275,220,"O to retry",black)
	screen:print(275,230,"Start to quit",black)
	flash=flash+3
	if flash>60 then flash=3 end
	if Controls.read():start() then dofile("home/game/mario.lua") end
	if Controls.read():circle() then break end
	backc=backc+d
	if backc>80 or backc<2 then d=-d end
	screen.waitVblankStart()
	screen.flip()
end

dofile("home/game/script_en_mario.lua")
